## -*- texinfo -*-
## @deftypefn  {} {} dummy()
##
## This is a dummy function documentation. This file have a lot functions
## and each one have a little documentation. This text is to avoid a warning when
## install this file as part of package.
##
## Set the graphics toolkit and force read this file as script file (not a function file).
##
graphics_toolkit qt;
##


##
##
## Begin callbacks definitions 
##

## @deftypefn  {} {} mainDlg_btnExit_doIt (@var{src}, @var{data}, @var{mainDlg})
##
## Define a callback for default action of btnExit control.
##
## @end deftypefn
function mainDlg_btnExit_doIt(src, data, mainDlg)

% El código que se indique aquí será ejecutado cuando el usuario presione en el botón.
close(mainDlg.figure);
end

## @deftypefn  {} {} mainDlg_btnPlot_doIt (@var{src}, @var{data}, @var{mainDlg})
##
## Define a callback for default action of btnPlot control.
##
## @end deftypefn
function mainDlg_btnPlot_doIt(src, data, mainDlg)

% El código que se indique aquí será ejecutado cuando el usuario presione en el botón.
par = struct( ...
	"xMin", str2num(get(mainDlg.edXMin, 'String')), ...
	"xMax", str2num(get(mainDlg.edXMax, 'String')), ...
	"xStp", str2num(get(mainDlg.edStep, 'String')), ...
	"yMin", str2num(get(mainDlg.edYMin, 'String')), ...
	"yMax", str2num(get(mainDlg.edYMax, 'String')) ...
	);
fcnId = get(mainDlg.cmbFcn, 'Value');
doPlot (fcnId, par, mainDlg.pltImg);
end

## @deftypefn  {} {} mainDlg_btnOpen_doIt (@var{src}, @var{data}, @var{mainDlg})
##
## Define a callback for default action of btnOpen control.
##
## @end deftypefn
function mainDlg_btnOpen_doIt(src, data, mainDlg)

% El código que se indique aquí será ejecutado cuando el usuario presione en el botón.
par = struct( ...
	"xMin", str2num(get(mainDlg.edXMin, 'String')), ...
	"xMax", str2num(get(mainDlg.edXMax, 'String')), ...
	"xStp", str2num(get(mainDlg.edStep, 'String')), ...
	"yMin", str2num(get(mainDlg.edYMin, 'String')), ...
	"yMax", str2num(get(mainDlg.edYMax, 'String')) ...
	);
fcnId = get(mainDlg.cmbFcn, 'Value');
newFg = figure();
ax = gca();
doPlot (fcnId, par, ax);
end

## @deftypefn  {} {} mainDlg_btnSave_doIt (@var{src}, @var{data}, @var{mainDlg})
##
## Define a callback for default action of btnSave control.
##
## @end deftypefn
function mainDlg_btnSave_doIt(src, data, mainDlg)

% El código que se indique aquí será ejecutado cuando el usuario presione en el botón.
 filters ={"*.ps", "PostScript"; ...
           "*.eps", "Encapsulated PostScript"; ...
           "*.pdf", "Portable Document Format"; ...
           "*.jpg", "JPEG Image"; ...
           "*.png", "PNG Image"};

 [fname, fpath, fltidx] = uiputfile (filters, "Save plot as image");
 if(fname)
   saveas(mainDlg.pltImg, [fpath filesep() fname]);
 endif 
end

## @deftypefn  {} {} mainDlg_cmbFcn_doIt (@var{src}, @var{data}, @var{mainDlg})
##
## Define a callback for default action of cmbFcn control.
##
## @end deftypefn
function mainDlg_cmbFcn_doIt(src, data, mainDlg)

% The code added here will be executed when an item is selected from
% the list (even if the same value is selected that was already set)

par = struct( ...
	"xMin", str2num(get(mainDlg.edXMin, 'String')), ...
	"xMax", str2num(get(mainDlg.edXMax, 'String')), ...
	"xStp", str2num(get(mainDlg.edStep, 'String')), ...
	"yMin", str2num(get(mainDlg.edYMin, 'String')), ...
	"yMax", str2num(get(mainDlg.edYMax, 'String')) ...
	);
fcnId = get(mainDlg.cmbFcn, 'Value');
doPlot (fcnId, par, mainDlg.pltImg);
end

## @deftypefn  {} {} mainDlg_btnAbout_doIt (@var{src}, @var{data}, @var{mainDlg})
##
## Define a callback for default action of btnAbout control.
##
## @end deftypefn
function mainDlg_btnAbout_doIt(src, data, mainDlg)

% El código que se indique aquí será ejecutado cuando el usuario presione en el botón.
aboutDlg();
end

 
## @deftypefn  {} {@var{ret} = } show_mainDlg(varargin)
##
## Create windows controls over a figure, link controls with callbacks and return 
## a window struct representation.
##
## @end deftypefn
function ret = show_mainDlg(varargin)
  _scrSize = get(0, "screensize");
  global _simpleplotImgPath;
  _xPos = (_scrSize(3) - 555)/2;
  _yPos = (_scrSize(4) - 278)/2;
   mainDlg = figure ( ... 
	'Color', [0.941 0.941 0.941], ...
	'name', 'Plot example', ...
	'numbertitle', 'off', ...
	'Position', [_xPos _yPos 555 278], ...
	'Resize', 'off', ...
	'toolbar', 'auto', ...
	'windowstyle', 'normal', ...
	'MenuBar', 'none');
	 set(mainDlg, 'visible', 'off');
  pltImg = axes( ...
	'Units', 'pixels', ... 
	'parent',mainDlg, ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'Position', [33 74 307 154], ... 
	'visible', 'on');
  btnExit = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [438 21 90 22], ... 
	'String', 'Exit', ... 
	'TooltipString', 'Exit application', ... 
	'visible', 'on');
  btnPlot = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [338 21 90 22], ... 
	'String', 'Update', ... 
	'TooltipString', 'Update the plot with actual parameters', ... 
	'visible', 'on');
  Label_1 = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'bold', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [35 239 181 16], ... 
	'String', 'Plot of the specified function', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  GroupPanel_1 = uipanel( ...
	'parent',mainDlg, ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'BorderWidth', 1, ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [360 73 181 195], ... 
	'title', 'Limits:', ... 
	'TitlePosition', 'lefttop', ... 
	'visible', 'on');
  edXMin = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [70 141 90 22], ... 
	'String', '0.0', ... 
	'TooltipString', 'X minimal value for the plot', ... 
	'visible', 'on');
  Label_2 = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [15 144 36 16], ... 
	'String', 'x min:', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  Label_3 = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [15 114 40 16], ... 
	'String', 'x max:', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  Label_4 = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [15 54 36 16], ... 
	'String', 'y min:', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  Label_5 = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [15 24 40 16], ... 
	'String', 'y max:', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  Label_6 = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [15 84 40 16], ... 
	'String', 'x step:', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  edXMax = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [70 111 90 22], ... 
	'String', '6.28', ... 
	'TooltipString', 'X max value for the plot', ... 
	'visible', 'on');
  edYMin = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [70 51 90 22], ... 
	'String', '-1.0', ... 
	'TooltipString', 'Min value for the y axis', ... 
	'visible', 'on');
  edYMax = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [70 21 90 22], ... 
	'String', '1.0', ... 
	'TooltipString', 'Max value for the y axis', ... 
	'visible', 'on');
  edStep = uicontrol( ...
	'parent',GroupPanel_1, ... 
	'Style','edit', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [1.000 1.000 1.000], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'center', ... 
	'Position', [70 81 90 22], ... 
	'String', '0.01', ... 
	'TooltipString', 'Horizontal steps (from x min to x max)', ... 
	'visible', 'on');
  btnOpen = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [280 236 25 22], ... 
	'String', '+', ... 
	'TooltipString', 'Open a new figure with the plot', ... 
	'visible', 'on');
  btnSave = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [312 236 28 22], ... 
	'String', 's', ... 
	'TooltipString', 'Save the figure as image file', ... 
	'visible', 'on');
  cmbFcn = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','popupmenu', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [91 19 127 25], ... 
	'String', 'sin(x)|cos(x)|exp(-x) * sin(12x)', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  Label_8 = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','text', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'HorizontalAlignment', 'left', ... 
	'Position', [27 24 54 16], ... 
	'String', 'Function:', ... 
	'TooltipString', '', ... 
	'visible', 'on');
  btnAbout = uicontrol( ...
	'parent',mainDlg, ... 
	'Style','pushbutton', ... 
	'Units', 'pixels', ... 
	'BackgroundColor', [0.941 0.941 0.941], ... 
	'FontAngle', 'normal', ... 
	'FontName', 'Arial', ... 
	'FontSize', 10, 'FontUnits', 'points', ... 
	'FontWeight', 'normal', ... 
	'ForegroundColor', [0.000 0.000 0.000], ... 
	'Position', [235 21 90 22], ... 
	'String', 'About', ... 
	'TooltipString', '', ... 
	'visible', 'on');

  mainDlg = struct( ...
      'figure', mainDlg, ...
      'pltImg', pltImg, ...
      'btnExit', btnExit, ...
      'btnPlot', btnPlot, ...
      'Label_1', Label_1, ...
      'GroupPanel_1', GroupPanel_1, ...
      'edXMin', edXMin, ...
      'Label_2', Label_2, ...
      'Label_3', Label_3, ...
      'Label_4', Label_4, ...
      'Label_5', Label_5, ...
      'Label_6', Label_6, ...
      'edXMax', edXMax, ...
      'edYMin', edYMin, ...
      'edYMax', edYMax, ...
      'edStep', edStep, ...
      'btnOpen', btnOpen, ...
      'btnSave', btnSave, ...
      'cmbFcn', cmbFcn, ...
      'Label_8', Label_8, ...
      'btnAbout', btnAbout);


  set (btnExit, 'callback', {@mainDlg_btnExit_doIt, mainDlg});
  set (btnPlot, 'callback', {@mainDlg_btnPlot_doIt, mainDlg});
  set (btnOpen, 'callback', {@mainDlg_btnOpen_doIt, mainDlg});
  set (btnSave, 'callback', {@mainDlg_btnSave_doIt, mainDlg});
  set (cmbFcn, 'callback', {@mainDlg_cmbFcn_doIt, mainDlg});
  set (btnAbout, 'callback', {@mainDlg_btnAbout_doIt, mainDlg});
  dlg = struct(mainDlg);

  set(mainDlg.figure, 'visible', 'on');

%
% El código fuente escrito aquí será ejecutado cuando
% la ventana se haga visible. Funciona como el evento 'onLoad' de otros lenguajes.
%

par = struct( ...
	"xMin", str2num(get(mainDlg.edXMin, 'String')), ...
	"xMax", str2num(get(mainDlg.edXMax, 'String')), ...
	"xStp", str2num(get(mainDlg.edStep, 'String')), ...
	"yMin", str2num(get(mainDlg.edYMin, 'String')), ...
	"yMax", str2num(get(mainDlg.edYMax, 'String')) ...
	);
fcnId = get(mainDlg.cmbFcn, 'Value');
doPlot (fcnId, par, mainDlg.pltImg);
refresh();
  ret = mainDlg;
end

## @end deftypefn

